# install.packages("ggmap")
# install.packages("sf")

library(readr)
library(ggmap)
library(rethinking)
library(reshape2)
library(ggthemes)
library(sf)
library(dplyr)


suicide <- read_csv("san_francisco_suicide_2003_2017.csv")

suicide <- as.data.frame(suicide)

names(___)
head(____)
nrow(____)


suicide$Descript[1:15]


#we need to get the map first
#you can check coordinates at:
#https://boundingbox.klokantech.com/



sf_map <-ggmap(get_map(c(-122.530392,37.698887,-122.351177,37.812996), source ="stamen"))


sf_map


sf_map+geom_point(aes(x =X,y =Y), data = suicide)


#E1 clean up Descript column, divide into attempted and accomplished and color by it;
#tweak size and alpha to make this look legible

str(suicide$Descript)


suicide_____ <- as.factor(___________)


# check the levels of factorized column
levels(____________)


# in levels specify the categories that will cover all attempted cases,
# hint: in levels 9 first categories covers all "attempted" cases;
# hint2: ":" this argument creates a natural number sequence with difference 1
suicide$status <- ifelse(__________ %in% levels(_________)[_:_],
                         "attempted", "successful")


# status is a category, it needs to be factorized 
# to make the visualization work, so do it and check the levels
suicide$status <- __________

levels(_________)



# The columns X and Y are our longitude and latitude columns,
# color by status
sf_map+geom_point(aes(__________), data = ______, 
                  size = ___, alpha = ___)





#E2 Fix these parameters to make this looks nice
#make sure one region stands out (it might ask you to install smth)
# use ONLY X and Y in aes()

sf_map+stat_binhex(_____________,
                   bins =60, data = _______)+
  coord_cartesian()



sf_map+stat_binhex(_____________,
                   bins = ______, _________, alpha = _____)+
  coord_cartesian()



#now add +scale_fill_gradient(low ="#ffeda0",high ="#f03b20")
#and revise sizes (bins) and alpha

sf_map+stat_binhex(____________,
                   _____________________________)+
  coord_cartesian()+____________________________






# Now let's use the whole neighborhoods
# load the data:

suicide$downtown <- (suicide$X < -122.446722 & suicide$Y > 37.773827)


suicide$statusID <- as.integer(suicide$status) - 1
str(suicide$statusID)

suicide$downtownID <- as.integer(suicide$downtown) + 1
str(suicide$downtownID)


sf_neighborhoods <-st_read("san_francisco_neighborhoods.shp")

sf_neighborhoods <-st_transform(sf_neighborhoods,crs =2227)

plot(sf_neighborhoods$geometry)


#E3 NOW BY NEIGHBORHOODS, run the following lines
# try to understand what they do

suicideGeo <-st_as_sf(suicide,coords =c("X","Y"), crs ="+proj=longlat +ellps=WGS84 +no_defs")
suicideGeo <- st_transform(suicideGeo,crs =st_crs(sf_neighborhoods))

suicideGeo <- st_join(suicideGeo, sf_neighborhoods)

head(suicideGeo)


suicideGeo$number_suicides <-1

names(suicideGeo)

suicideGeo$statusID

n_suicides <- aggregate(number_suicides ~ nhood, data = suicideGeo, FUN =sum)
n_successes <- aggregate(statusID ~ nhood, data = suicideGeo, FUN =sum)


neighborhoods <- merge(n_suicides,n_successes)


head(neighborhoods)


# let's joint the data, to the table with coordintates,
# one slightly above of Ex 3, add the table created here
sf_neighboorhood_summaries <- left_join(______, _______)


head(sf_neighboorhood_summaries)


________________________$number_suicides[is.na(
  _______________________$number_suicides)] <- 0




# one for suicides and one for attempted suicidies, check head() or names()
# of a data frame to pick the right columns
# add a theme
ggplot(______________________,aes(fill =___________))+geom_sf()+__________

ggplot((______________________,aes(fill =___________))+geom_sf()+__________



# now let's visualize suicide succes rate by neighberhood
# in fill argument put the ratio of attempted suicides to succesfull ones
# add: scale_fill_gradient('success rate', low ="skyblue",high ="darkorange")

# also, add a theme, and give it a title
       
ggplot(___________________,aes(fill = _______/_______))+
  ______


# try changing the theme to theme_void()

ggplot(___________________,aes(fill = _______/_______))+
  ______


# try to add: geom_sf_text(aes(label =paste( round(statusID/number_suicides * 100, 0), "%")), size = 2.5,
# color = "black", fontface = "bold", alpha = 0.8)



ggplot(___________________,aes(fill = _______/_______))+
  ______


# try to represent probabilities as percentages in geom_sf_text
# use paste(____, "%") to add a % symbol (after transforming the values :) )



ggplot(___________________,aes(fill = _______/_______))+
  ______



ggsave("neighborhoods.pdf")





